"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.distributeToAssetAndClaim = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const mpl_core_1 = require("@metaplex-foundation/mpl-core");
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const generated_1 = require("./generated");
function distributeToAssetAndClaim(umi, args) {
    let builder = new umi_1.TransactionBuilder();
    const assetSigner = (0, mpl_core_1.findAssetSignerPda)(umi, {
        asset: args.asset,
    })[0];
    const assetSignerTokenAccount = (0, mpl_toolbox_1.findAssociatedTokenPda)(umi, {
        owner: assetSigner,
        mint: (0, umi_1.publicKey)(args.mint),
    });
    const assetOwnerTokenAccount = (0, mpl_toolbox_1.findAssociatedTokenPda)(umi, {
        owner: args.recipient,
        mint: (0, umi_1.publicKey)(args.mint),
    });
    builder = builder.add((0, generated_1.distribute)(umi, {
        ...args,
        recipient: assetSigner,
    }));
    builder = builder.add((0, mpl_core_1.execute)(umi, {
        asset: {
            publicKey: args.asset,
        },
        instructions: (0, mpl_toolbox_1.transferTokens)(umi, {
            source: assetSignerTokenAccount,
            destination: assetOwnerTokenAccount,
            amount: args.amount,
            authority: (0, umi_1.createNoopSigner)(assetSigner),
        }).add((0, mpl_toolbox_1.closeToken)(umi, {
            account: assetSignerTokenAccount,
            destination: args.recipient,
            owner: (0, umi_1.createNoopSigner)(assetSigner),
        })),
    }));
    return builder;
}
exports.distributeToAssetAndClaim = distributeToAssetAndClaim;
//# sourceMappingURL=core.js.map