"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchClaimReceiptFromSeeds = exports.fetchClaimReceiptFromSeeds = exports.findClaimReceiptPda = exports.getClaimReceiptSize = exports.getClaimReceiptGpaBuilder = exports.safeFetchAllClaimReceipt = exports.fetchAllClaimReceipt = exports.safeFetchClaimReceipt = exports.fetchClaimReceipt = exports.deserializeClaimReceipt = exports.getClaimReceiptAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getClaimReceiptAccountDataSerializer() {
    return (0, serializers_1.struct)([
        ['key', (0, types_1.getKeySerializer)()],
        ['bump', (0, serializers_1.u8)()],
        ['padding', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 6 })],
        ['distribution', (0, serializers_1.publicKey)()],
        ['recipient', (0, serializers_1.publicKey)()],
        ['amount', (0, serializers_1.u64)()],
        ['nonce', (0, serializers_1.u64)()],
    ], { description: 'ClaimReceiptAccountData' });
}
exports.getClaimReceiptAccountDataSerializer = getClaimReceiptAccountDataSerializer;
function deserializeClaimReceipt(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getClaimReceiptAccountDataSerializer());
}
exports.deserializeClaimReceipt = deserializeClaimReceipt;
async function fetchClaimReceipt(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'ClaimReceipt');
    return deserializeClaimReceipt(maybeAccount);
}
exports.fetchClaimReceipt = fetchClaimReceipt;
async function safeFetchClaimReceipt(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeClaimReceipt(maybeAccount) : null;
}
exports.safeFetchClaimReceipt = safeFetchClaimReceipt;
async function fetchAllClaimReceipt(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'ClaimReceipt');
        return deserializeClaimReceipt(maybeAccount);
    });
}
exports.fetchAllClaimReceipt = fetchAllClaimReceipt;
async function safeFetchAllClaimReceipt(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeClaimReceipt(maybeAccount));
}
exports.safeFetchAllClaimReceipt = safeFetchAllClaimReceipt;
function getClaimReceiptGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplDistro', 'D1STRoZTUiEa6r8TLg2aAbG4nSRT5cDBmgG7jDqCZvU8');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        bump: [1, (0, serializers_1.u8)()],
        padding: [2, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 6 })],
        distribution: [8, (0, serializers_1.publicKey)()],
        recipient: [40, (0, serializers_1.publicKey)()],
        amount: [72, (0, serializers_1.u64)()],
        nonce: [80, (0, serializers_1.u64)()],
    })
        .deserializeUsing((account) => deserializeClaimReceipt(account));
}
exports.getClaimReceiptGpaBuilder = getClaimReceiptGpaBuilder;
function getClaimReceiptSize() {
    return 88;
}
exports.getClaimReceiptSize = getClaimReceiptSize;
function findClaimReceiptPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplDistro', 'D1STRoZTUiEa6r8TLg2aAbG4nSRT5cDBmgG7jDqCZvU8');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('claim_receipt'),
        (0, serializers_1.publicKey)().serialize(seeds.distribution),
        (0, serializers_1.publicKey)().serialize(seeds.recipient),
        (0, serializers_1.u64)().serialize(seeds.amount),
        (0, serializers_1.u64)().serialize(seeds.nonce),
    ]);
}
exports.findClaimReceiptPda = findClaimReceiptPda;
async function fetchClaimReceiptFromSeeds(context, seeds, options) {
    return fetchClaimReceipt(context, findClaimReceiptPda(context, seeds), options);
}
exports.fetchClaimReceiptFromSeeds = fetchClaimReceiptFromSeeds;
async function safeFetchClaimReceiptFromSeeds(context, seeds, options) {
    return safeFetchClaimReceipt(context, findClaimReceiptPda(context, seeds), options);
}
exports.safeFetchClaimReceiptFromSeeds = safeFetchClaimReceiptFromSeeds;
//# sourceMappingURL=claimReceipt.js.map