/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Account, Context, Pda, PublicKey, RpcAccount, RpcGetAccountOptions, RpcGetAccountsOptions } from '@metaplex-foundation/umi';
import { Serializer } from '@metaplex-foundation/umi/serializers';
import { Key, KeyArgs } from '../types';
export type Distribution = Account<DistributionAccountData>;
export type DistributionAccountData = {
    key: Key;
    bump: number;
    padding: Array<number>;
    authority: PublicKey;
    mint: PublicKey;
    merkleRoot: Uint8Array;
    startTime: bigint;
    endTime: bigint;
    totalClaimants: bigint;
    totalAmount: bigint;
    claimCount: bigint;
    claimAmount: bigint;
    seed: PublicKey;
    name: Uint8Array;
};
export type DistributionAccountDataArgs = {
    key: KeyArgs;
    bump: number;
    padding: Array<number>;
    authority: PublicKey;
    mint: PublicKey;
    merkleRoot: Uint8Array;
    startTime: number | bigint;
    endTime: number | bigint;
    totalClaimants: number | bigint;
    totalAmount: number | bigint;
    claimCount: number | bigint;
    claimAmount: number | bigint;
    seed: PublicKey;
    name: Uint8Array;
};
export declare function getDistributionAccountDataSerializer(): Serializer<DistributionAccountDataArgs, DistributionAccountData>;
export declare function deserializeDistribution(rawAccount: RpcAccount): Distribution;
export declare function fetchDistribution(context: Pick<Context, 'rpc'>, publicKey: PublicKey | Pda, options?: RpcGetAccountOptions): Promise<Distribution>;
export declare function safeFetchDistribution(context: Pick<Context, 'rpc'>, publicKey: PublicKey | Pda, options?: RpcGetAccountOptions): Promise<Distribution | null>;
export declare function fetchAllDistribution(context: Pick<Context, 'rpc'>, publicKeys: Array<PublicKey | Pda>, options?: RpcGetAccountsOptions): Promise<Distribution[]>;
export declare function safeFetchAllDistribution(context: Pick<Context, 'rpc'>, publicKeys: Array<PublicKey | Pda>, options?: RpcGetAccountsOptions): Promise<Distribution[]>;
export declare function getDistributionGpaBuilder(context: Pick<Context, 'rpc' | 'programs'>): import("@metaplex-foundation/umi").GpaBuilder<Distribution, {
    key: KeyArgs;
    bump: number;
    padding: Array<number>;
    authority: PublicKey;
    mint: PublicKey;
    merkleRoot: Uint8Array;
    startTime: number | bigint;
    endTime: number | bigint;
    totalClaimants: number | bigint;
    totalAmount: number | bigint;
    claimCount: number | bigint;
    claimAmount: number | bigint;
    seed: PublicKey;
    name: Uint8Array;
}>;
export declare function getDistributionSize(): number;
export declare function findDistributionPda(context: Pick<Context, 'eddsa' | 'programs'>, seeds: {
    /** The address of the mint */
    mint: PublicKey;
    /** The address of the seed */
    seed: PublicKey;
}): Pda;
export declare function fetchDistributionFromSeeds(context: Pick<Context, 'eddsa' | 'programs' | 'rpc'>, seeds: Parameters<typeof findDistributionPda>[1], options?: RpcGetAccountOptions): Promise<Distribution>;
export declare function safeFetchDistributionFromSeeds(context: Pick<Context, 'eddsa' | 'programs' | 'rpc'>, seeds: Parameters<typeof findDistributionPda>[1], options?: RpcGetAccountOptions): Promise<Distribution | null>;
