"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchDistributionFromSeeds = exports.fetchDistributionFromSeeds = exports.findDistributionPda = exports.getDistributionSize = exports.getDistributionGpaBuilder = exports.safeFetchAllDistribution = exports.fetchAllDistribution = exports.safeFetchDistribution = exports.fetchDistribution = exports.deserializeDistribution = exports.getDistributionAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const types_1 = require("../types");
function getDistributionAccountDataSerializer() {
    return (0, serializers_1.struct)([
        ['key', (0, types_1.getKeySerializer)()],
        ['bump', (0, serializers_1.u8)()],
        ['padding', (0, serializers_1.array)((0, serializers_1.u8)(), { size: 6 })],
        ['authority', (0, serializers_1.publicKey)()],
        ['mint', (0, serializers_1.publicKey)()],
        ['merkleRoot', (0, serializers_1.bytes)({ size: 32 })],
        ['startTime', (0, serializers_1.i64)()],
        ['endTime', (0, serializers_1.i64)()],
        ['totalClaimants', (0, serializers_1.u64)()],
        ['totalAmount', (0, serializers_1.u64)()],
        ['claimCount', (0, serializers_1.u64)()],
        ['claimAmount', (0, serializers_1.u64)()],
        ['seed', (0, serializers_1.publicKey)()],
        ['name', (0, serializers_1.bytes)({ size: 32 })],
    ], { description: 'DistributionAccountData' });
}
exports.getDistributionAccountDataSerializer = getDistributionAccountDataSerializer;
function deserializeDistribution(rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getDistributionAccountDataSerializer());
}
exports.deserializeDistribution = deserializeDistribution;
async function fetchDistribution(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Distribution');
    return deserializeDistribution(maybeAccount);
}
exports.fetchDistribution = fetchDistribution;
async function safeFetchDistribution(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount((0, umi_1.publicKey)(publicKey, false), options);
    return maybeAccount.exists ? deserializeDistribution(maybeAccount) : null;
}
exports.safeFetchDistribution = safeFetchDistribution;
async function fetchAllDistribution(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Distribution');
        return deserializeDistribution(maybeAccount);
    });
}
exports.fetchAllDistribution = fetchAllDistribution;
async function safeFetchAllDistribution(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys.map((key) => (0, umi_1.publicKey)(key, false)), options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeDistribution(maybeAccount));
}
exports.safeFetchAllDistribution = safeFetchAllDistribution;
function getDistributionGpaBuilder(context) {
    const programId = context.programs.getPublicKey('mplDistro', 'D1STRoZTUiEa6r8TLg2aAbG4nSRT5cDBmgG7jDqCZvU8');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)()],
        bump: [1, (0, serializers_1.u8)()],
        padding: [2, (0, serializers_1.array)((0, serializers_1.u8)(), { size: 6 })],
        authority: [8, (0, serializers_1.publicKey)()],
        mint: [40, (0, serializers_1.publicKey)()],
        merkleRoot: [72, (0, serializers_1.bytes)({ size: 32 })],
        startTime: [104, (0, serializers_1.i64)()],
        endTime: [112, (0, serializers_1.i64)()],
        totalClaimants: [120, (0, serializers_1.u64)()],
        totalAmount: [128, (0, serializers_1.u64)()],
        claimCount: [136, (0, serializers_1.u64)()],
        claimAmount: [144, (0, serializers_1.u64)()],
        seed: [152, (0, serializers_1.publicKey)()],
        name: [184, (0, serializers_1.bytes)({ size: 32 })],
    })
        .deserializeUsing((account) => deserializeDistribution(account));
}
exports.getDistributionGpaBuilder = getDistributionGpaBuilder;
function getDistributionSize() {
    return 216;
}
exports.getDistributionSize = getDistributionSize;
function findDistributionPda(context, seeds) {
    const programId = context.programs.getPublicKey('mplDistro', 'D1STRoZTUiEa6r8TLg2aAbG4nSRT5cDBmgG7jDqCZvU8');
    return context.eddsa.findPda(programId, [
        (0, serializers_1.string)({ size: 'variable' }).serialize('distribution'),
        (0, serializers_1.publicKey)().serialize(seeds.mint),
        (0, serializers_1.publicKey)().serialize(seeds.seed),
    ]);
}
exports.findDistributionPda = findDistributionPda;
async function fetchDistributionFromSeeds(context, seeds, options) {
    return fetchDistribution(context, findDistributionPda(context, seeds), options);
}
exports.fetchDistributionFromSeeds = fetchDistributionFromSeeds;
async function safeFetchDistributionFromSeeds(context, seeds, options) {
    return safeFetchDistribution(context, findDistributionPda(context, seeds), options);
}
exports.safeFetchDistributionFromSeeds = safeFetchDistributionFromSeeds;
//# sourceMappingURL=distribution.js.map