/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Context, Pda, PublicKey, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { Serializer } from '@metaplex-foundation/umi/serializers';
import { PickPartial } from '../shared';
export type DistributeInstructionAccounts = {
    /** The address of the new distribution */
    distribution: PublicKey | Pda;
    /** The address of the mint account */
    mint: PublicKey | Pda;
    /** The claim receipt account to track that this claim was processed */
    claimReceipt?: PublicKey | Pda;
    /** The recipient's token account receiving tokens */
    recipientTokenAccount?: PublicKey | Pda;
    /** The distribution's token account sending tokens */
    distributionTokenAccount?: PublicKey | Pda;
    /** The recipient's address */
    recipient?: PublicKey | Pda;
    /** The account paying for the storage fees */
    payer?: Signer;
    /** The wallet where fees are sent */
    feeWallet?: PublicKey | Pda;
    /** The associated token program */
    associatedTokenProgram?: PublicKey | Pda;
    /** The token program */
    tokenProgram?: PublicKey | Pda;
    /** The system program */
    systemProgram?: PublicKey | Pda;
};
export type DistributeInstructionData = {
    discriminator: number;
    amount: bigint;
    proof: Array<Uint8Array>;
    nonce: bigint;
};
export type DistributeInstructionDataArgs = {
    amount: number | bigint;
    proof: Array<Uint8Array>;
    nonce?: number | bigint;
};
export declare function getDistributeInstructionDataSerializer(): Serializer<DistributeInstructionDataArgs, DistributeInstructionData>;
export type DistributeInstructionArgs = PickPartial<DistributeInstructionDataArgs, 'nonce'>;
export declare function distribute(context: Pick<Context, 'eddsa' | 'payer' | 'programs'>, input: DistributeInstructionAccounts & DistributeInstructionArgs): TransactionBuilder;
