"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.distribute = exports.getDistributeInstructionDataSerializer = void 0;
const mpl_toolbox_1 = require("@metaplex-foundation/mpl-toolbox");
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
function getDistributeInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.u8)()],
        ['amount', (0, serializers_1.u64)()],
        ['proof', (0, serializers_1.array)((0, serializers_1.bytes)({ size: 32 }))],
        ['nonce', (0, serializers_1.u64)()],
    ], { description: 'DistributeInstructionData' }), (value) => ({ ...value, discriminator: 4, nonce: value.nonce ?? 0 }));
}
exports.getDistributeInstructionDataSerializer = getDistributeInstructionDataSerializer;
// Instruction.
function distribute(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplDistro', 'D1STRoZTUiEa6r8TLg2aAbG4nSRT5cDBmgG7jDqCZvU8');
    // Accounts.
    const resolvedAccounts = {
        distribution: {
            index: 0,
            isWritable: true,
            value: input.distribution ?? null,
        },
        mint: { index: 1, isWritable: false, value: input.mint ?? null },
        claimReceipt: {
            index: 2,
            isWritable: true,
            value: input.claimReceipt ?? null,
        },
        recipientTokenAccount: {
            index: 3,
            isWritable: true,
            value: input.recipientTokenAccount ?? null,
        },
        distributionTokenAccount: {
            index: 4,
            isWritable: true,
            value: input.distributionTokenAccount ?? null,
        },
        recipient: {
            index: 5,
            isWritable: false,
            value: input.recipient ?? null,
        },
        payer: {
            index: 6,
            isWritable: true,
            value: input.payer ?? null,
        },
        feeWallet: {
            index: 7,
            isWritable: true,
            value: input.feeWallet ?? null,
        },
        associatedTokenProgram: {
            index: 8,
            isWritable: false,
            value: input.associatedTokenProgram ?? null,
        },
        tokenProgram: {
            index: 9,
            isWritable: false,
            value: input.tokenProgram ?? null,
        },
        systemProgram: {
            index: 10,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedArgs.nonce) {
        resolvedArgs.nonce = 0;
    }
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.claimReceipt.value) {
        if (resolvedAccounts.recipient.value) {
            resolvedAccounts.claimReceipt.value = (0, accounts_1.findClaimReceiptPda)(context, {
                distribution: (0, shared_1.expectPublicKey)(resolvedAccounts.distribution.value),
                recipient: (0, shared_1.expectPublicKey)(resolvedAccounts.recipient.value),
                amount: (0, shared_1.expectSome)(resolvedArgs.amount),
                nonce: (0, shared_1.expectSome)(resolvedArgs.nonce),
            });
        }
        else {
            resolvedAccounts.claimReceipt.value = (0, accounts_1.findClaimReceiptPda)(context, {
                distribution: (0, shared_1.expectPublicKey)(resolvedAccounts.distribution.value),
                recipient: (0, shared_1.expectPublicKey)(resolvedAccounts.payer.value),
                amount: (0, shared_1.expectSome)(resolvedArgs.amount),
                nonce: (0, shared_1.expectSome)(resolvedArgs.nonce),
            });
        }
    }
    if (!resolvedAccounts.recipientTokenAccount.value) {
        if (resolvedAccounts.recipient.value) {
            resolvedAccounts.recipientTokenAccount.value = (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
                mint: (0, shared_1.expectPublicKey)(resolvedAccounts.mint.value),
                owner: (0, shared_1.expectPublicKey)(resolvedAccounts.recipient.value),
            });
        }
        else {
            resolvedAccounts.recipientTokenAccount.value = (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
                mint: (0, shared_1.expectPublicKey)(resolvedAccounts.mint.value),
                owner: (0, shared_1.expectPublicKey)(resolvedAccounts.payer.value),
            });
        }
    }
    if (!resolvedAccounts.distributionTokenAccount.value) {
        resolvedAccounts.distributionTokenAccount.value = (0, mpl_toolbox_1.findAssociatedTokenPda)(context, {
            mint: (0, shared_1.expectPublicKey)(resolvedAccounts.mint.value),
            owner: (0, shared_1.expectPublicKey)(resolvedAccounts.distribution.value),
        });
    }
    if (!resolvedAccounts.feeWallet.value) {
        resolvedAccounts.feeWallet.value = (0, umi_1.publicKey)('9kFjQsxtpBsaw8s7aUyiY3wazYDNgFP4Lj5rsBVVF8tb');
    }
    if (!resolvedAccounts.associatedTokenProgram.value) {
        resolvedAccounts.associatedTokenProgram.value = (0, umi_1.publicKey)('ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL');
    }
    if (!resolvedAccounts.tokenProgram.value) {
        resolvedAccounts.tokenProgram.value = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
        resolvedAccounts.tokenProgram.isWritable = false;
    }
    if (!resolvedAccounts.systemProgram.value) {
        resolvedAccounts.systemProgram.value = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
        resolvedAccounts.systemProgram.isWritable = false;
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getDistributeInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.distribute = distribute;
//# sourceMappingURL=distribute.js.map