"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateDistribution = exports.getUpdateDistributionInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const serializers_1 = require("@metaplex-foundation/umi/serializers");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
function getUpdateDistributionInstructionDataSerializer() {
    return (0, serializers_1.mapSerializer)((0, serializers_1.struct)([
        ['discriminator', (0, serializers_1.u8)()],
        ['merkleRoot', (0, serializers_1.option)((0, serializers_1.bytes)({ size: 32 }))],
        ['startTime', (0, serializers_1.option)((0, serializers_1.i64)())],
        ['endTime', (0, serializers_1.option)((0, serializers_1.i64)())],
        ['totalClaimants', (0, serializers_1.option)((0, serializers_1.u64)())],
        ['newAuthority', (0, serializers_1.option)((0, serializers_1.publicKey)())],
        ['name', (0, serializers_1.option)((0, serializers_1.string)())],
    ], { description: 'UpdateDistributionInstructionData' }), (value) => ({
        ...value,
        discriminator: 1,
        merkleRoot: value.merkleRoot ?? (0, umi_1.none)(),
        startTime: value.startTime ?? (0, umi_1.none)(),
        endTime: value.endTime ?? (0, umi_1.none)(),
        totalClaimants: value.totalClaimants ?? (0, umi_1.none)(),
        newAuthority: value.newAuthority ?? (0, umi_1.none)(),
        name: value.name ?? (0, umi_1.none)(),
    }));
}
exports.getUpdateDistributionInstructionDataSerializer = getUpdateDistributionInstructionDataSerializer;
// Instruction.
function updateDistribution(context, input) {
    // Program ID.
    const programId = context.programs.getPublicKey('mplDistro', 'D1STRoZTUiEa6r8TLg2aAbG4nSRT5cDBmgG7jDqCZvU8');
    // Accounts.
    const resolvedAccounts = {
        distribution: {
            index: 0,
            isWritable: true,
            value: input.distribution ?? null,
        },
        payer: {
            index: 1,
            isWritable: true,
            value: input.payer ?? null,
        },
        authority: {
            index: 2,
            isWritable: false,
            value: input.authority ?? null,
        },
        feeWallet: {
            index: 3,
            isWritable: true,
            value: input.feeWallet ?? null,
        },
        systemProgram: {
            index: 4,
            isWritable: false,
            value: input.systemProgram ?? null,
        },
    };
    // Arguments.
    const resolvedArgs = { ...input };
    // Default values.
    if (!resolvedAccounts.payer.value) {
        resolvedAccounts.payer.value = context.payer;
    }
    if (!resolvedAccounts.feeWallet.value) {
        resolvedAccounts.feeWallet.value = (0, umi_1.publicKey)('9kFjQsxtpBsaw8s7aUyiY3wazYDNgFP4Lj5rsBVVF8tb');
    }
    if (!resolvedAccounts.systemProgram.value) {
        resolvedAccounts.systemProgram.value = context.programs.getPublicKey('splSystem', '11111111111111111111111111111111');
        resolvedAccounts.systemProgram.isWritable = false;
    }
    // Accounts in order.
    const orderedAccounts = Object.values(resolvedAccounts).sort((a, b) => a.index - b.index);
    // Keys and Signers.
    const [keys, signers] = (0, shared_1.getAccountMetasAndSigners)(orderedAccounts, 'programId', programId);
    // Data.
    const data = getUpdateDistributionInstructionDataSerializer().serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = (0, accounts_1.getDistributionSize)() + umi_1.ACCOUNT_HEADER_SIZE;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.updateDistribution = updateDistribution;
//# sourceMappingURL=updateDistribution.js.map