/// <reference types="node" />
export interface MerkleTreeContext {
    leaves: Array<Buffer>;
    layers: Array<Array<Buffer>>;
}
export declare function createMerkleTree(leaves: Array<Buffer>): MerkleTreeContext;
export declare function nodeHash(data: Buffer): Buffer;
export declare function internalHash(first: Buffer, second: Buffer | undefined): Buffer;
export declare function getRoot(tree: MerkleTreeContext): Buffer;
export declare function getProof(tree: MerkleTreeContext, idx: number): Buffer[];
export declare function getHexRoot(tree: MerkleTreeContext): string;
export declare function getHexProof(tree: MerkleTreeContext, idx: number): string[];
export declare function verifyProof(tree: MerkleTreeContext, idx: number, proof: Buffer[], root: Buffer): boolean;
export declare function verifyClaim(leaf: Buffer, proof: Buffer[], root: Buffer): boolean;
